//+------------------------------------------------------------------+
//|                                                 Weekly Trade.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property indicator_chart_window
//#property indicator_separate_window

extern int period = 20;
extern int BarShift = 1;
extern string Comment1 = "Use KeepLine to enable appropriate lines no change in other timeframes.";
extern string Comment2 = "Monthly = 43200";
extern string Comment3 = "Weekly = 10080";
extern string Comment4 = "Daily = 1440";
extern string Comment5 = "4 hours = 240";
extern string Comment6 = "1 hour = 60";
extern string Comment7 = "30 minutes = 30";
extern string Comment8 = "15 minutes = 15";
extern string Comment9 = "5 minutes = 5";
extern string Comment10 = "1 minutes = 1"; 
extern bool KeepLine = true;
extern int KeepLineForTF = 10080;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    Comment(" ");
    ObjectDelete("Line20");
    ObjectDelete("Line80");
    ObjectDelete("Line10");
    ObjectDelete("Line90");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int Type = PriceType();
   int i;
   int j;
   int counted_bars = IndicatorCounted();
   //Alert(counted_bars," & ", Bars);
   if(counted_bars < 0) 
        return(-1);
   int e = Bars - counted_bars;
   //Alert (e);
   if(e > Bars) 
        e = Bars;
   //Alert(Period());
   //Alert(TimeFrame(Period()));
   string TF1 = TimeFrame(Period());
   
   //Alert("Type = ", Type);
   //Alert("TypePrice = ",Type);
   double Length[];
   double Mid[];
   double Slope[];
   ArrayResize(Length, period+1+BarShift); 
   ArraySetAsSeries(Length, true);
   ArrayResize(Mid, period+1+BarShift); 
   ArraySetAsSeries(Mid, true);
   ArrayResize(Slope,period+1+BarShift);
   ArraySetAsSeries(Slope,true); 
   j=0;
   for (i=period+BarShift;i>=BarShift;i--)
   {
      //Alert(i);
      //Alert(i);
      Mid[j] = NormalizeDouble((High[i]+Low[i])/2,Type);
      //Alert("Midpi ",Mid[j], " & ", j);
      //Alert ((High[i]-Low[i])/2, " & ",i);
      if (i != period+BarShift) 
      {
          //Alert ("Vao ",i);
          Length[j] = (High[i]-Low[i])/Mid[j];
          //Alert(Length[j], " & ", j);
          //Alert(Mid[i] , " & ",Mid[i+1]);
          Slope[j] = Mid[j]/Mid[j-1];
          //Alert(Slope[j], " va ", j);
          //Comment("Slope = ",Slope[i]);
          
      }
      j=j+1;
   }
   double Tong;
   for (j=1;j<=period;j++)
   {
      Tong=Tong+Length[j];
   }
   double AverLength;
   AverLength = Tong/period;
   //Alert("AverLength = ",AverLength);
  
   double SumSlope;
   for (j=1;j<=period;j++) SumSlope = SumSlope + Slope[j];
   double AverSlope;
   AverSlope = SumSlope/period; 
   //Alert ("SumSlope = ",AverSlope);
   
   double ProjectMid; 
   double ProjectMin;
   double ProjectMax;
   double Project80;
   double Project20;
   double Project90;
   double Project10;
   ProjectMid = NormalizeDouble(Mid[period]*AverSlope,Type);
   //Alert (ProjectMid);
   ProjectMax = NormalizeDouble (ProjectMid + ((ProjectMid*AverLength)/2),Type);
   ProjectMin = NormalizeDouble (ProjectMid - ((ProjectMid*AverLength)/2),Type);
   //Alert("Weekly Min = ", ProjectMin , " & Weekly Max = ", ProjectMax);
   Project80 = NormalizeDouble (ProjectMid + ((ProjectMid*AverLength)*0.3),Type);
   Project20 = NormalizeDouble (ProjectMid - ((ProjectMid*AverLength)*0.3),Type);
   Project90 = NormalizeDouble (ProjectMid + ((ProjectMid*AverLength)*0.4),Type);
   Project10 = NormalizeDouble (ProjectMid - ((ProjectMid*AverLength)*0.4),Type);
   //Alert("80 = ", Project80," 20 = ",Project20," 90 = ",Project90," 10 = ",Project10);
   if (KeepLine == true && Period() != KeepLineForTF) {
       int TFrame;
       switch (KeepLineForTF)
       {
            case 1:TFrame = PERIOD_M1; break;
            case 5:TFrame = PERIOD_M5; break;
            case 15:TFrame = PERIOD_M15; break;
            case 30:TFrame = PERIOD_M30; break;
            case 60:TFrame = PERIOD_H1; break;
            case 240:TFrame = PERIOD_H4; break;
            case 1440:TFrame = PERIOD_D1; break;
            case 10080:TFrame = PERIOD_W1; break;
            case 43200:TFrame = PERIOD_MN1; break;
       }
   //Alert(PERIOD_D1);
   //Alert(Old20," & ",Old80);
   double MTFProjectMin;
   double MTFProjectMax;
   double MTFProject10;
   double MTFProject20;
   double MTFProject80;
   double MTFProject90;
   WeeklyCalculate(TFrame,Type,period,BarShift,MTFProjectMin,MTFProjectMax,MTFProject10,MTFProject20,MTFProject80,MTFProject90);
   //Alert(MTFProjectMin);
   string TFrameString = TimeFrame(TFrame);
   Comment("\n Weekly 80/20 system (Period = ", period ,",BarShift = ", BarShift, ",KeepLine = True,KeepLineForTF = ", TimeFrame(KeepLineForTF) ,") for "+ TFrameString + " :\n  - Projected ", TFrameString ," Min = ", MTFProjectMin ," \n  - Projected ", TFrameString ," Max = ", MTFProjectMax ,
             "\n  - Projected " + TFrameString + " 10% = ", MTFProject10 ," \n  - Projected " + TFrameString + " 90% = ", MTFProject90 ,
             "\n  - Projected " + TFrameString + " 20% = ", MTFProject20 ," \n  - Projected " + TFrameString + " 80% = ", MTFProject80 ,
             "\n\n Calculate for ", TF1 , " :\n  - Projected " + TF1 + " Min = ",ProjectMin,"\n  - Projected " + TF1 + " Max = ", ProjectMax ,
             "\n  - Projected " + TF1 + " 10% = ", Project10 , " \n  - Projected " + TF1 + " 90% = ", Project90 ,
             "\n  - Projected " + TF1 + " 20% = ", Project20 , " \n  - Projected " + TF1 + " 80% = ", Project80);
   ObjectDelete("Line20");
   ObjectDelete("Line80");
   ObjectDelete("Line10");
   ObjectDelete("Line90");
   HLine("Line20",Chartreuse,MTFProject20);
   HLine("Line80",Red,MTFProject80);
   HLine("Line10",Chartreuse,MTFProject10);
   HLine("Line90",Red,MTFProject90);
   } 
   
   else {
        if (KeepLine == false) {
             Comment("\n Weekly 80/20 system (Period = ", period ,",BarShift = ", BarShift, ",KeepLine = False) for "+ TF1 + " :\n  - Projected ", TF1 ," Min = ", ProjectMin ," \n  - Projected ", TF1 ," Max = ", ProjectMax ,
             "\n  - Projected " + TF1 + " 10% = ", Project10 ," \n  - Projected " + TF1 + " 90% = ", Project90 ,
             "\n  - Projected " + TF1 + " 20% = ", Project20 ," \n  - Projected " + TF1 + " 80% = ", Project80);
        }
        else if (KeepLine == true && Period() == KeepLineForTF) {
             Comment("\n Weekly 80/20 system (Period = ", period ,",BarShift = ", BarShift, ",KeepLine = True,KeepLineForTF = ", TimeFrame(KeepLineForTF) ,") for "+ TF1 + " :\n  - Projected ", TF1 ," Min = ", ProjectMin ," \n  - Projected ", TF1 ," Max = ", ProjectMax ,
             "\n  - Projected " + TF1 + " 10% = ", Project10 ," \n  - Projected " + TF1 + " 90% = ", Project90 ,
             "\n  - Projected " + TF1 + " 20% = ", Project20 ," \n  - Projected " + TF1 + " 80% = ", Project80);
        }
        ObjectDelete("Line20");
        ObjectDelete("Line80");
        ObjectDelete("Line10");
        ObjectDelete("Line90");
        HLine("Line20",Chartreuse,Project20);
        HLine("Line80",Red,Project80);
        HLine("Line10",Chartreuse,Project10);
        HLine("Line90",Red,Project90);
   }
  
   //ObjectDelete("Pro1");
   //TextLabel("Pro1",110, 15,3);
   //ObjectSetText( "Pro1","Test"+ NormalizeDouble(ProjectMin,Type), 15, "Arial Bold", Red ); 
//----
   return(0);
  }
//+------------------------------------------------------------------+

int WeeklyCalculate(int ChartTF,int Type,int KiHan,int Shift,double& ResultMin,double& ResultMax,double& Result10,double& Result20,double& Result80,double& Result90)
{
   double iLength[];
   double iMid[];
   double iSlope[];
   int i,j;
   ArrayResize(iLength, KiHan+1+Shift); 
   ArraySetAsSeries(iLength, true);
   ArrayResize(iMid, KiHan+1+Shift); 
   ArraySetAsSeries(iMid, true);
   ArrayResize(iSlope,KiHan+1+Shift);
   ArraySetAsSeries(iSlope,true); 
   j=0;
   for (i=KiHan+Shift;i>=Shift;i--)
   {
      //Alert(i);
      //Alert(i);
      iMid[j] = NormalizeDouble((iHigh(NULL,ChartTF,i)+iLow(NULL,ChartTF,i))/2,Type);
      //Alert("Midpi ",Mid[j], " & ", j);
      //Alert ((High[i]-Low[i])/2, " & ",i);
      if (i != KiHan+Shift) 
      {
          //Alert ("Vao ",i);
          iLength[j] = (iHigh(NULL,ChartTF,i)-iLow(NULL,ChartTF,i))/iMid[j];
          //Alert(Length[j], " & ", j);
          //Alert(Mid[i] , " & ",Mid[i+1]);
          iSlope[j] = iMid[j]/iMid[j-1];
          //Alert(Slope[j], " va ", j);
          //Comment("Slope = ",Slope[i]);
          
      }
      j=j+1;
   }
   double iTong;
   for (j=1;j<=KiHan;j++)
   {
      iTong=iTong+iLength[j];
   }
   double iAverLength;
   iAverLength = iTong/KiHan;
   //Alert("AverLength = ",AverLength);
  
   double iSumSlope;
   for (j=1;j<=KiHan;j++) iSumSlope = iSumSlope + iSlope[j];
   double iAverSlope;
   iAverSlope = iSumSlope/KiHan; 
   //Alert ("SumSlope = ",AverSlope);
   
   double ResultMid; 
   
   ResultMid = NormalizeDouble(iMid[KiHan]*iAverSlope,Type);
   //Alert (ProjectMid);
   ResultMax = NormalizeDouble (ResultMid + ((ResultMid*iAverLength)/2),Type);
   ResultMin = NormalizeDouble (ResultMid - ((ResultMid*iAverLength)/2),Type);
   //Alert("Weekly Min = ", ProjectMin , " & Weekly Max = ", ProjectMax);
   Result80 = NormalizeDouble (ResultMid + ((ResultMid*iAverLength)*0.3),Type);
   Result20 = NormalizeDouble (ResultMid - ((ResultMid*iAverLength)*0.3),Type);
   Result90 = NormalizeDouble (ResultMid + ((ResultMid*iAverLength)*0.4),Type);
   Result10 = NormalizeDouble (ResultMid - ((ResultMid*iAverLength)*0.4),Type);
}


int TextLabel(string Text,int x,int y,int iCorner) {
  ObjectCreate(Text,OBJ_LABEL,0,0,0);
  ObjectSet(Text,OBJPROP_CORNER,iCorner);
  ObjectSet(Text,OBJPROP_XDISTANCE , x);
  ObjectSet(Text,OBJPROP_YDISTANCE , y);
  ObjectSet   (Text,OBJPROP_BACK      , True );
}
 
int HLine(string Name,color Color,double Value)
{
  ObjectCreate(Name,OBJ_HLINE,0,0,Value);
  ObjectSet(Name,OBJPROP_STYLE,STYLE_SOLID);
  ObjectSet(Name,OBJPROP_WIDTH,2);
  ObjectSet(Name,OBJPROP_COLOR,Color);
  ObjectSet(Name,OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);
  ObjectSet(Name,OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);
}
  
int CreateText(string Name,string Text,color Color,double Value)
{
  ObjectCreate(Name,OBJ_TEXT,0,Time[1],Value);
  ObjectSetText(Name,Text,10,"Times New Roman",Color);
}

int PriceType()
{
  double Value;
  int Pos,i;
  for (i=0;i<=8;i++)
  {
      Value = Point*mu(i);
      //Alert(NewValue);
      if (Value == 1) {
          Pos = i;
          break;
      }
  }
  return(Pos);
}

double mu(int k) 
{
  double h =1;
  int i;
  for (i=1;i<=k;i++) h = h*10;
  return(h);
}

string TimeFrame(int Value)
{
  string TF;
  if (Value == 1) {
      TF = "1 minute (M1)";
  }
  else if (Value == 5) {
      TF = "5 minutes (M5)";
  }
  else if (Value == 15) {
      TF = "15 minutes (M15)";
  } 
  else if (Value == 30) {
      TF = "30 minutes (M30)";
  }
  else if (Value == 60) {
      TF = "1 hour (H1)";
  }
  else if (Value == 240) {
      TF = "4 hours (H4)";
  }
  else if (Value == 1440) {
      TF = "Daliy (D1)";
  }
  else if (Value == 10080) {
      TF = "Weekly (W1)";
  }
  else if (Value == 43200) {
      TF = "Monthly (MN)";
  }
  return(TF);
}